Index: issm/trunk/src/c/modules/UpdateInputsFromVectorx/UpdateInputsFromVectorx.h
===================================================================
--- issm/trunk/src/c/modules/UpdateInputsFromVectorx/UpdateInputsFromVectorx.h	(revision 3912)
+++ issm/trunk/src/c/modules/UpdateInputsFromVectorx/UpdateInputsFromVectorx.h	(revision 3913)
@@ -6,6 +6,6 @@
 #define _UPDATEINPUTSFROMVECTORXX_H
 
-#include "../objects/objects.h"
-#include "../DataSet/DataSet.h"
+#include "../../objects/objects.h"
+#include "../../DataSet/DataSet.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp
===================================================================
--- issm/trunk/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp	(revision 3912)
+++ issm/trunk/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.cpp	(revision 3913)
@@ -5,8 +5,8 @@
 #include "./UpdateVertexPositionsx.h"
 
-#include "../shared/shared.h"
-#include "../include/include.h"
-#include "../toolkits/toolkits.h"
-#include "../EnumDefinitions/EnumDefinitions.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
 
 void UpdateVertexPositionsx( DataSet* vertices, Vec thickness,Vec bed){
Index: issm/trunk/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.h
===================================================================
--- issm/trunk/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.h	(revision 3912)
+++ issm/trunk/src/c/modules/UpdateVertexPositionsx/UpdateVertexPositionsx.h	(revision 3913)
@@ -6,5 +6,5 @@
 #define _UPDATEVERTEXPOSITIONSXX_H
 
-#include "../DataSet/DataSet.h"
+#include "../../DataSet/DataSet.h"
 
 /* local prototypes: */
Index: issm/trunk/src/c/objects/Bamg/CrackedEdge.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/CrackedEdge.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/CrackedEdge.cpp	(revision 3913)
@@ -0,0 +1,33 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "CrackedEdge.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+	/*FUNCTION CrackedEdge() {{{1*/
+	CrackedEdge::CrackedEdge() {
+		a=NULL;
+		b=NULL;
+		E=NULL;
+		e1=NULL;
+		e2=NULL;
+		indexa[0]=-1;
+		indexa[1]=-1;
+		indexa[2]=-1;
+		indexb[0]=-1;
+		indexb[1]=-1;
+		indexb[2]=-1;
+		length=0;
+		normal.x=0;
+		normal.y=0;
+
+	}
+	/*}}}*/
+
+	/*Methods*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/CrackedEdge.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/CrackedEdge.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/CrackedEdge.h	(revision 3913)
@@ -0,0 +1,31 @@
+#ifndef _CRACKEDEDGE_H_
+#define _CRACKEDEDGE_H_
+
+#include "./typedefs.h"
+
+namespace bamg {
+
+	//classes
+	class Triangle;
+	class GeometricalEdge;
+	class Edge;
+
+	class CrackedEdge {
+
+		public:
+			Triangle* a;
+			Triangle* b; 
+			GeometricalEdge* E;
+			Edge* e1;
+			Edge* e2;
+			double length;
+			R2     normal;
+			long   indexa[3];
+			long   indexb[3];
+
+			//Constructors
+			CrackedEdge();
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/Curve.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/Curve.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Curve.cpp	(revision 3913)
@@ -0,0 +1,23 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "Curve.h"
+#include "Geometry.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+
+	/*Methods*/
+	/*FUNCTION Curve::Set {{{1*/
+	void Curve::Set(const Curve & rec,const Geometry & Gh ,Geometry & GhNew){
+		*this = rec;
+		be = GhNew.edges + Gh.Number(be);    
+		ee = GhNew.edges + Gh.Number(ee); 
+		if(next) next= GhNew.curves + Gh.Number(next); 
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/Curve.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/Curve.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Curve.h	(revision 3913)
@@ -0,0 +1,27 @@
+#ifndef _CURVE_H_
+#define _CURVE_H_
+
+#include "../../shared/Bamg/shared.h"
+
+namespace bamg {
+
+	//classes
+	class GeometricalEdge;
+	class Curve;
+	class Geometry;
+
+	class Curve {
+		public:
+			GeometricalEdge * be,*ee; // begin et end edge
+			int kb,ke;  //  begin vetex and end vertex
+			Curve* next; // next curve equi to this
+			bool master; // true => of equi curve point on this curve  
+
+			//Methods
+			Curve() : be(0),ee(0),kb(0),ke(0),next(0),master(true) {} 
+			void Reverse() { Exchange(be,ee); Exchange(kb,ke);} //  revese the sens of the curse 
+			void Set(const Curve & rec,const Geometry & Th ,Geometry & ThNew);
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/Direction.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/Direction.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Direction.cpp	(revision 3913)
@@ -0,0 +1,31 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "Direction.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+	/*FUNCTION Direction(Icoor1 i,Icoor1 j) {{{1*/
+	Direction::Direction(Icoor1 i,Icoor1 j) {
+		Icoor2 n2 = 2*(Abs(i)+Abs(j));  
+		Icoor2 r  = MaxICoor* (Icoor2) i;
+		Icoor1 r1 = (Icoor1) (2*(r/ n2)); // odd number 
+		dir = (j>0) ? r1 : r1+1;          // odd-> j>0 even-> j<0
+	}/*}}}*/
+
+	/*Methods*/
+	/*FUNCTION Direction::sens{{{1*/
+	int Direction::sens(Icoor1 i,Icoor1 j) {
+		int r =1; 
+		if (dir!= MaxICoor) {
+			Icoor2 x(dir/2),y1(MaxICoor/2-Abs(x)),y(dir%2?-y1:y1);
+			r = (x*i + y*j) >=0;
+		}
+		return r;
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/Direction.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/Direction.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Direction.h	(revision 3913)
@@ -0,0 +1,21 @@
+#ifndef _DIRECTION_H_
+#define _DIRECTION_H_
+
+#include "./include.h"
+#include "../../shared/Bamg/shared.h"
+
+namespace bamg {
+
+	class Direction {
+		private:
+			Icoor1 dir;
+
+		public:
+			//Methods
+			Direction(): dir(MaxICoor){}; //  no direction set
+			Direction(Icoor1 i,Icoor1 j);
+			int sens(Icoor1 i,Icoor1 j);
+	};
+}
+#endif
+
Index: issm/trunk/src/c/objects/Bamg/DoubleAndInt.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/DoubleAndInt.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/DoubleAndInt.h	(revision 3913)
@@ -0,0 +1,19 @@
+#ifndef _DOUBLEANDINT_H_
+#define _DOUBLEANDINT_H_
+
+#include "./include.h"
+
+namespace bamg {
+
+	class DoubleAndInt {
+		//class used by Triangles::MakeQuadrangles
+
+		public:
+			double q;
+			long i3j;
+
+			//Operators
+			int operator<(DoubleAndInt a){return q > a.q;}
+	};
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/Edge.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/Edge.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Edge.cpp	(revision 3913)
@@ -0,0 +1,36 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "Edge.h"
+#include "Triangles.h"
+#include "Geometry.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+
+	/*Methods*/
+	/*FUNCTION Edge::Set {{{1*/
+	void Edge::Set(const Triangles & Th ,long i,Triangles & ThNew){ 
+		*this = Th.edges[i];
+		v[0] = ThNew.vertices + Th.Number(v[0]);    
+		v[1] = ThNew.vertices + Th.Number(v[1]);
+		if (onGeometry) 
+		 onGeometry =  ThNew.Gh.edges+Th.Gh.Number(onGeometry);
+		if (adj[0]) adj[0] =   ThNew.edges +   Th.Number(adj[0]);
+		if (adj[1]) adj[1] =   ThNew.edges +   Th.Number(adj[1]);
+	}
+	/*}}}*/
+	/*FUNCTION Edge::Echo {{{1*/
+	void Edge::Echo(void){ 
+		printf("Edge:\n");
+		printf("   pointers towards two vertices: %p %p\n",v[0],v[1]);
+		printf("   ref = %i\n",ref);
+		printf("   onGeometry = %p\n",onGeometry);
+		printf("   two adjacent edges on the same curve: %p %p\n",adj[0],adj[1]);
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/Edge.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/Edge.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Edge.h	(revision 3913)
@@ -0,0 +1,49 @@
+#ifndef _EDGE_H_
+#define _EDGE_H_
+
+#include "./include.h"
+#include "./MeshVertex.h"
+#include "../../include/include.h"
+#include "../../shared/Exceptions/exceptions.h"
+#include "./GeometricalEdge.h"
+
+namespace bamg {
+
+	//classes
+	class Triangles;
+	
+	class Edge {
+
+		public:
+			MeshVertex* v[2];
+			long ref;
+			GeometricalEdge* onGeometry;
+			Edge* adj[2]; // the 2 adj edges if on the same curve 
+
+			//Operators
+			MeshVertex & operator[](int i){return *v[i];};
+			MeshVertex * operator()(int i){return v[i];};
+			R2       operator()(double t) const; // return the point 
+			const MeshVertex & operator[](int i) const { return *v[i];};
+
+			//Methods
+			void ReNumbering(MeshVertex *vb,MeshVertex *ve, long *renu){
+				if (v[0] >=vb && v[0] <ve) v[0] = vb + renu[v[0]-vb];
+				if (v[1] >=vb && v[1] <ve) v[1] = vb + renu[v[1]-vb];
+			}
+			int Intersection(const  Edge & e) const { 
+				if (!(adj[0]==&e || adj[1]==&e)){
+					ISSMERROR("Intersection bug");
+				}
+				if (adj[0]!=&e && adj[1]!=&e){
+					ISSMERROR("adj[0]!=&e && adj[1]!=&e");
+				}
+				return adj[0]==&e ? 0 : 1;
+			}
+			void Set(const Triangles &,long,Triangles &);
+			void Echo(void);
+
+	};
+}
+#endif
+
Index: issm/trunk/src/c/objects/Bamg/GeometricalEdge.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/GeometricalEdge.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/GeometricalEdge.cpp	(revision 3913)
@@ -0,0 +1,141 @@
+#include <cstdio>
+#include <string.h>
+#include <cmath>
+
+#include "../../include/include.h"
+#include "../../shared/Exceptions/exceptions.h"
+
+#include "GeometricalEdge.h"
+#include "Geometry.h"
+
+using namespace std;
+
+namespace bamg {
+
+	/*Constructor/Destructor*/
+
+	/*Methods*/
+	/*FUNCTION GeometricalEdge::R1tg{{{1*/
+	double GeometricalEdge::R1tg(double theta,R2 & t) const{
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, MeshGeom.cpp/R1tg)*/
+		// 1/R of radius of cuvature
+
+		R2 A=v[0]->r,B=v[1]->r;
+		double dca,dcb,dcta,dctb;
+		double ddca,ddcb,ddcta,ddctb;
+		double tt = theta*theta;
+
+		//check theta
+		ISSMASSERT(theta>=0 && theta<=1);
+
+		if (TgA()){ 
+			if (TgB()){
+				// Tangent A and B provided:
+				// interpolation d'hermite
+				dcb = 6*theta*(1-theta);
+				ddcb = 6*(1-2*theta);
+				dca = -dcb;
+				ddca = -ddcb;
+				dcta =  (3*theta - 4)*theta + 1;
+				ddcta=6*theta-4;
+				dctb = 3*tt - 2*theta;
+				ddctb = 6*theta-2;
+			}
+			else {
+				//Tangent A provided but tangent B not provided
+				// 1-t*t, t-t*t, t*t
+				double t = theta;
+				dcb = 2*t;
+				ddcb = 2;
+				dca = -dcb;
+				ddca = -2;
+				dcta = 1-dcb;
+				ddcta = -ddcb;
+				dctb=0;    
+				ddctb=0;    
+			}
+		}
+		else{
+			if (TgB()){
+				//Tangent B provided but tangent A not provided
+				double t = 1-theta;
+				dca = -2*t;
+				ddca = 2;
+				dcb = -dca;
+				ddcb = -2;
+				dctb = 1+dca;
+				ddctb= ddca;
+				dcta =0;
+				ddcta =0;
+			}
+			else {
+				//Neither thangent A nor tangent B provided
+				// lagrange P1
+				t=B-A;
+				return 0;
+			} 
+		}
+		R2 d  =  A*dca  + B*dcb  + tg[0]* dcta  + tg[1] * dctb;
+		R2 dd =  A*ddca + B*ddcb + tg[0]* ddcta + tg[1] * ddctb;
+		double d2=(d,d);
+		double sd2 = sqrt(d2);
+		t=d;
+		if(d2>1.0e-20){
+			t/=sd2;
+			return Abs(Det(d,dd))/(d2*sd2);
+		}
+		else return 0;
+	}
+	/*}}}1*/
+	/*FUNCTION GeometricalEdge::F{{{1*/
+	R2 GeometricalEdge::F(double theta) const{
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, MeshGeom.cpp/F)*/
+		// parametrization of the curve edge
+
+	   R2 A=v[0]->r,B=v[1]->r;
+		double ca,cb,cta,ctb;
+		if ( theta<-1e-12){
+			ISSMERROR("theta<-1e-12");
+		}
+		if ( theta>1+1e-12){
+			ISSMERROR("theta>1+1e-12");
+		}
+		if (TgA()) 
+		 if (TgB()) // interpolation d'hermite
+			{ cb =  theta*theta*(3-2*theta);
+			 ca =  1-cb;     
+			 cta = (1-theta)*(1-theta)*theta;
+			 ctb = (theta-1)*theta*theta ;
+			}
+		 else { // 1-t*t, t-t*t, t*t
+			 double t = theta;
+			 cb = t*t;
+			 ca = 1-cb;
+			 cta= t-cb;
+			 ctb=0;    
+		 }    
+		else
+		 if (TgB()){
+			 double t = 1-theta;
+			 ca = t*t;
+			 cb = 1-ca;
+			 ctb= -t+ca;
+			 cta=0;    
+		 }
+		 else {
+			 ca =(1-theta),cb = theta,cta=ctb=0; // lagrange P1
+		 }
+		return A*ca + B*cb + tg[0]* cta + tg[1] * ctb;
+	  }
+	/*}}}1*/
+	/*FUNCTION GeometricalEdge::Set {{{1*/
+	void GeometricalEdge::Set(const GeometricalEdge & rec,const Geometry & Gh ,Geometry & GhNew){ 
+		*this = rec;
+		v[0] = GhNew.vertices + Gh.Number(v[0]);    
+		v[1] = GhNew.vertices + Gh.Number(v[1]); 
+		if (Adj[0]) Adj[0] =  GhNew.edges + Gh.Number(Adj[0]);     
+		if (Adj[1]) Adj[1] =  GhNew.edges + Gh.Number(Adj[1]);     
+	}
+	/*}}}*/
+
+}
Index: issm/trunk/src/c/objects/Bamg/GeometricalEdge.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/GeometricalEdge.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/GeometricalEdge.h	(revision 3913)
@@ -0,0 +1,47 @@
+#ifndef _GEOMETRICALEDGE_H_
+#define _GEOMETRICALEDGE_H_
+
+#include "./include.h"
+
+namespace bamg {
+
+	//classes
+	class GeometricalVertex;
+	class Geometry;
+
+	class GeometricalEdge {
+
+		public:
+			GeometricalVertex* v[2];
+			long ref;
+			long CurveNumber;
+			R2   tg[2]; // the 2 tangentes (tg[0] =0 => no continuity)
+			GeometricalEdge* Adj[2]; 
+			int DirAdj[2];
+			int flag ;
+
+			//Operators
+			GeometricalVertex       & operator[](int i){return *v[i];};
+			const GeometricalVertex & operator[](int i) const { return *v[i];};
+			GeometricalVertex       * operator()(int i){return v[i];};  
+
+			//Methods
+			R2     F(double theta) const ; // parametrization of the curve edge
+			double R1tg(double theta,R2 &t) const ; // 1/radius of curvature + tangente
+			int    Tg(int i) const{return i==0 ? TgA() : TgB();}
+			int    Cracked() const    {return flag & 1;  }
+			int    TgA()const         {return flag & 4;  }
+			int    TgB()const         {return flag & 8;  }
+			int    Mark()const        {return flag & 16; }
+			int    Required()         {return flag & 64; }
+			void   SetCracked()     { flag |= 1;  }
+			void   SetTgA()         { flag |=4;   }
+			void   SetTgB()         { flag |=8;   }
+			void   SetMark()        { flag |=16;  }
+			void   SetUnMark()      { flag &= 1007 /* 1023-16*/;}
+			void   SetRequired()    { flag |= 64; }
+			void   Set(const GeometricalEdge & rec,const Geometry & Th ,Geometry & ThNew);
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/GeometricalSubDomain.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/GeometricalSubDomain.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/GeometricalSubDomain.cpp	(revision 3913)
@@ -0,0 +1,20 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "GeometricalSubDomain.h"
+#include "Geometry.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+
+	/*Methods*/
+	/*FUNCTION GeometricalSubDomain::Set {{{1*/
+	void GeometricalSubDomain::Set(const GeometricalSubDomain & rec,const Geometry & Gh ,const Geometry & GhNew){
+		*this = rec;
+		edge = Gh.Number(edge) + GhNew.edges;
+	}/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/GeometricalSubDomain.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/GeometricalSubDomain.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/GeometricalSubDomain.h	(revision 3913)
@@ -0,0 +1,23 @@
+#ifndef _GEOMETRICALSUBDOMAIN_H_
+#define _GEOMETRICALSUBDOMAIN_H_
+
+#include "./include.h"
+
+namespace bamg {
+
+	//classes
+	class GeometricalEdge;
+	class Geometry;
+
+	class GeometricalSubDomain {
+		public:
+			GeometricalEdge *edge;
+			int sens; // -1 or 1
+			long ref;
+
+			//Methods
+			void Set(const GeometricalSubDomain &,const Geometry & ,const Geometry &);
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/GeometricalVertex.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/GeometricalVertex.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/GeometricalVertex.cpp	(revision 3913)
@@ -0,0 +1,54 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "GeometricalVertex.h"
+#include "../../include/include.h"
+#include "../../shared/Exceptions/exceptions.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+	//See header file
+
+	/*Methods*/
+	/*FUNCTION GeometricalVertex::Corner {{{1*/
+	int  GeometricalVertex::Corner() const {
+		return cas & 4;
+	}
+	/*}}}*/
+	/*FUNCTION GeometricalVertex::Required {{{1*/
+	int  GeometricalVertex::Required()const {
+		// a corner is required
+		return cas & 6;
+	}
+	/*}}}*/
+	/*FUNCTION GeometricalVertex::IsThe {{{1*/
+	int  GeometricalVertex::IsThe() const {
+		return link == this;
+	}  
+	/*}}}*/
+	/*FUNCTION GeometricalVertex::SetCorner {{{1*/
+	void GeometricalVertex::SetCorner(){
+		cas |= 4;
+	}
+	/*}}}*/
+	/*FUNCTION GeometricalVertex::SetRequired {{{1*/
+	void GeometricalVertex::SetRequired(){
+		cas |= 2;
+	}
+	/*}}}*/
+	/*FUNCTION GeometricalVertex::Set {{{1*/
+	void GeometricalVertex::Set(){
+		cas=0;
+	}
+	/*}}}*/
+	/*FUNCTION GeometricalVertex::The {{{1*/
+	GeometricalVertex* GeometricalVertex::The(){
+		// return a unique vertex
+		ISSMASSERT(link);
+		return link;
+	}/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/GeometricalVertex.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/GeometricalVertex.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/GeometricalVertex.h	(revision 3913)
@@ -0,0 +1,38 @@
+#ifndef _GEOMETRICALVERTEX_H_
+#define _GEOMETRICALVERTEX_H_
+
+#include "./include.h"
+#include "MeshVertex.h"
+
+namespace bamg {
+
+	class Geometry;
+
+	class GeometricalVertex : public MeshVertex { 
+
+		public:
+			friend class Geometry;
+
+			int cas;
+			GeometricalVertex* link; //  link all the same GeometricalVertex circular (Crack) 
+
+			//Constructors
+			GeometricalVertex() :cas(0), link(this) {};
+
+			//Methods
+			int  Corner() const;
+			int  Required()const;
+			int  IsThe() const;
+			void SetCorner();
+			void SetRequired();
+			void Set();
+			GeometricalVertex* The();
+
+			//Inline methods
+			inline void Set(const GeometricalVertex & rec,const Geometry & ,const Geometry & ){
+				*this=rec;
+			}
+	};
+
+}
+#endif
